// Test polimorphic functions more!
// $Id: neat.g,v 1.2 2002/02/08 07:36:22 malekith Exp $
extern_c void print_string(string);
extern_c void print_int(int);

/* Takes multiplication function, and one element. Returns power function,
 * with Time = O(log n). */
*('a, int) -> 'a pow(*('a, 'a) -> 'a mul, 'a one)
{
	'a f('a val, int n) {
		if (n == 0)
			return one;
			
		if (n == 1)
			return val;
		
		'a res = f(val, n / 2);

		res = mul(res, res);
		
		if (n % 2 == 1)
			res = mul(res, val);

		return res;
	}

	return f;
}


int main() export_as "main"
{
	int int_mul(int x, int y) (x * y)
	
	/* First we make integer power function: */
	*(int, int) -> int int_pow = pow(int_mul, 1);

	/* and test it! */
	print_string("2 ^ 12 = ");
	print_int(int_pow(2, 12));
	print_string(", ");
	print_string("6 ^ 6 = ");
	print_int(int_pow(6, 6));
	print_string(", ");
	
	/* Now the funny part: */
	
	/* Return function, that applaies f n times. */
	*('a) -> 'a f_power_1(*('a) -> 'a f, int n)
	{
		/* In case of 0, return id function. */
		if (n == 0)
			return fun ('a x) -> 'a is (x);
			
		if (n == 1) {
			return f;
		} else {
			return fun ('a x) -> 'a is 
					(f((f_power_1(f, n - 1))(x)));
		}
	}

	/* But ain't happy with f_power_1 -- it takes O(n) time and
	 * space. Try use pow() function. */
	*('a) -> 'a combine(*('a) -> 'a f, *('a) -> 'a g)
	{
		return fun ('a x) -> 'a is (f(g(x)));
	}

	*(*('a) -> 'a, int) -> *('a) -> 'a f_power_2;

	f_power_2 = pow(combine, fun ('a x) -> 'a is (x));

	/* And test it! */
	*(int) -> int add_one = fun (int x) -> int is (x + 1);
	*(int) -> int add5_1 = f_power_1(add_one, 5);
	*(int) -> int add5_2 = f_power_2(add_one, 5);

	print_string("add5(10) = ");
	print_int(add5_1(10));
	print_string(" = ");
	print_int(add5_2(10));
	print_string("\n");

	return 0;
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: 2 ^ 12 = 4096, 6 ^ 6 = 46656, add5(10) = 15 = 15
 */
